/* (C) 2009 Yana */

#include "clock.h"
#include "tapdev.h"
#include "uip.h"

#include "device.h"
#include <string.h>

clock_time_t clock_time(void) {
	*(volatile unsigned int *)DEVICE_RTC_TRIGGER_READ;
	return *(volatile unsigned int *)DEVICE_RTC_SEC * CLOCK_SECOND + *(volatile unsigned int *)DEVICE_RTC_USEC * CLOCK_SECOND / 1000000;
}

void tapdev_init(void) {
}

unsigned int tapdev_read(void) {
	unsigned int result;
	if (*(volatile unsigned int *)DEVICE_ETHER_STATUS == 0) {
		return 0;
	}
	*(volatile unsigned int *)DEVICE_ETHER_COMMAND = DEVICE_ETHER_COMMAND_RX;
	result = *(volatile unsigned int *)DEVICE_ETHER_PACKETLENGTH;
	memcpy(uip_buf, (unsigned char *)DEVICE_ETHER_BUFFER, result);
	return result;
}

void tapdev_send(void) {
	memcpy((unsigned char *)DEVICE_ETHER_BUFFER, uip_buf, uip_len);
	*(volatile unsigned int *)DEVICE_ETHER_PACKETLENGTH = uip_len;
	*(volatile unsigned int *)DEVICE_ETHER_COMMAND = DEVICE_ETHER_COMMAND_TX;
}
